// mpview.c (1190.bicyclesonthemoon.info/silentbot/view)
// Display one post
// 25.04.2015
// 
// Copyright (C) 2015  Balthasar Szczepański
// 
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Affero General Public License as
// published by the Free Software Foundation, either version 3 of the
// License, or (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Affero General Public License for more details.
// 
// You should have received a copy of the GNU Affero General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.

#include <cgi.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/wait.h>

#define RM_PATH "/bin/rm"
#define CAT_PATH "/bin/cat"
#define MAWK_PATH "/usr/bin/mawk"

#define SENT_PATH "/eizm/mem/t1i/mpost/sent/"
#define WAIT_PATH "/eizm/mem/t1i/mpost/"

#define AWK_MVIEW "/eizm/pro/t1i/mview.awk"
#define TEMP_PATH "/eizm/tmp/t1i/mpview."

int main()
{
	s_cgi *cgi;
	pid_t sub;
	int r;
	
	char line[32];
	char filename[32];
	char postpath[256];
	char cat[8];
	
	char *arg;
	char key[64];
	
	char path2[256];
	
	cgi=cgiInit();
	
	dup2(fileno(stdout),fileno(stderr));
	
	printf("Content-type: text/html\n\n");
	
	arg=cgiGetValue(cgi,"v");
	sprintf(line,"%s",arg?arg:"???");
	
	arg=cgiGetValue(cgi,"key");
	sprintf(key,"key=%s",arg?arg:"???");
	
	if(line[0]=='s' && line[1]=='t')
	{
		sprintf(filename,"%s",line+2);
		sprintf(cat,"cat=%s","st");
		sprintf(postpath,"%s%s",SENT_PATH,filename);
	}
	else if(line[0]=='w' && line[1]=='t')
	{
		sprintf(filename,"%s",line+2);
		sprintf(cat,"cat=%s","wt");
		sprintf(postpath,"%s%s",WAIT_PATH,filename);
	}
	else 
	{
		sprintf(filename,"%s","???");
		sprintf(postpath,"%s","???");
		sprintf(cat,"cat=%s","???");
	}
	
	sprintf(path2,"%s%lu",TEMP_PATH,(unsigned long)getpid());
	
	printf("<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\" \"\">\n");
	printf("<html lang=\"en\"><head>\n");
	printf("<title>the Silent Chronotransponder &bull; Bicycles on the Moon</title>\n");
	printf("<meta http-equiv=\"Content-type\" content=\"text/html; charset=UTF-8\">\n");
	printf("<link rel=\"icon\" type=\"image/png\" href=\"/img/favicon.png\">\n");
	printf("<link rel=\"stylesheet\" href=\"/css/botm.css\">\n");
	printf("<script type=\"text/javascript\" src=\"/ott/prosilver/template/forum_fn.js\"></script>\n");
	printf("</head><body><a href=\"/\"><img src=\"/img/botmlogo2.png\" alt=\"1190.bicyclesonthemoon.info\" border=\"0\"></a>\n");
	printf("<h1>the Silent Chronotransponder</h1>\n");
	
	fflush(stdout);
	sub=fork();
	if(sub==0)
	{
		r=execl(MAWK_PATH,MAWK_PATH,"-f",AWK_MVIEW,"-v","bg=1","-v",cat,"-v","s=1","-v",key,postpath,(char *)0);
		exit(r);
	}
	waitpid(sub,&r,0);
	// if(r)
	// {
		// printf("<div id=\"%s\" class=\"post bg1\">\n",line);
		// printf("<div class=\"inner\"><span class=\"corners-top\"><span></span></span>\n");
		// printf("%s %s POST NOT FOUND.\n",AWK_MVIEW,postpath);
		// printf("<span class=\"corners-bottom\"><span></span></span>\n</div></div>\n");
		// printf("<hr class=\"divider\"></hr>\n");
	// }
	
	printf("<br><a href=\"/silentbot/list\">back to the Silent Chronotransponder</a><br>\n");
	printf("<br><a href=\"/\">1190.bicyclesonthemoon.info</a></body></html>\n");
	
	fflush(stdout);
	sub=fork();
	if(sub==0)
	{
		r=execl(RM_PATH,RM_PATH,"-f",path2,(char *)0);
		exit(r);
	}
	waitpid(sub,&r,0);
	if(r)
		printf("<p>Ch*rpin* M*stard! file not deleted!</p>");
	
	return 0;
}
