#// upload.awk
#// The post upload interface
#// 05.06.2015
#// 
#// Copyright (C) 2015  Balthasar Szczepański
#// 
#// This program is free software: you can redistribute it and/or modify
#// it under the terms of the GNU Affero General Public License as
#// published by the Free Software Foundation, either version 3 of the
#// License, or (at your option) any later version.
#// 
#// This program is distributed in the hope that it will be useful,
#// but WITHOUT ANY WARRANTY; without even the implied warranty of
#// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#// GNU Affero General Public License for more details.
#// 
#// You should have received a copy of the GNU Affero General Public License
#// along with this program.  If not, see <http://www.gnu.org/licenses/>.

BEGIN{
	postpath="/eizm/mem/t1i/mpost/"
	stpath="/eizm/mem/t1i/mpost/sent/"
	rmpath="/eizm/mem/t1i/mpost/rm/"
	bb2html="/eizm/pro/t1i/bb2html.awk"
	automome="/eizm/pro/ong1/mome.pl"
	memepath="/eizm/mem/ong1/mome.txt"
	timecmd="date -u +\"%s\""
	
	timecmd | getline thistime
		close(timecmd)
	
	srand(int(thistime) + int( PROCINFO["pid"]))
	
	for(i=0;i<256;++i)
	{
		ch=sprintf("%c",i)
		hex=sprintf("%02X",i)
		hexl=sprintf("%02x",i)
		dec=sprintf("%u",i)
		ch2hex[ch]=hex
		hex2ch[hex]=ch
		ch2hexl[ch]=hexl
		ch2dec[ch]=dec
	}
	
	year=substr(timetext,1,4)
	month=substr(timetext,5,2)
	day=substr(timetext,7,2)
	hour=substr(timetext,9,2)
	
	yyy=year+0
	mmm=month+0
	ddd=day+0
	hhh=hour+0
	
	ln=0
	memenumber=8
}
{
	gsub(/[\r\n]/,"",$0)
	if (FNR==1)
	{
		name=$0
		# print "username: "name
		next
	}
	if (FNR==2)
	{
		pass=$0
		gsub(/./,"*", $0)
		# print "password: "$0
		next
	}
	
	if($0=="")
	{
		if(ln!=0)
		{
			post()
			ln=0
			nobb=""
			nosmil=""
			nourl=""
			sig=""
			notify=""
			silent=""
			quot=""
			rmov=""
			lst=""
			flst=""
			h=""
			d=""
			m=""
			y=""
			subject=""
			content=""
			options=""
			# replace=""
		}
		next
	}
	
	++ln
	if(ln==1)
	{
		y=substr($0,1,4)
		m=substr($0,6,2)
		d=substr($0,9,2)
		h=substr($0,12,2)
		# #xxxx-xx-xx xx xxxx-xx-xx xx
		# if(length($0)>=27)
			# replace=substr($0,15,4)substr($0,20,2)substr($0,23,2)substr($0,26,2)
	}
	else if(ln==2)
	{
		options=tolower($0)
		if(options ~ /b/)
			nobb=1
		if(options ~ /s/)
			nosmil=1
		if(options ~ /u/)
			nourl=1
		if(options ~ /a/)
			sig=1
		if(options ~ /n/)
			notify=1
		if(options ~ /v/)
			silent=1
		if(options ~ /r/)
			rmov=1
		if(options ~ /q/)
			quot=1
		if(options ~ /l/)
			lst=1
		if(options ~ /f/)
			flst=1
	}
	else if(ln==3)
	{
		subject=$0
	}
	else
	{
		if(ln!=4)
			content=content "\n" $0
		else
			content=$0
	}

}
END{
	if(ln!=0)
		post()
}
function remove(   postid,postfile,rmfile,stfile,temp,f,tn,eq,tv)
{
	postid=sprintf("%04d%02d%02d%02d_%s",y,m,d,h,hexencode(name))
	postfile=postpath postid
	rmfile=rmpath postid
	stfile=stpath postid
	printf("%s",postid" ")
	
	while((getline temp < postfile)>0)
	{
		f=1
		gsub(/[\r\n]/,"",temp)
		eq=index(temp,"=")
		tn=substr(temp,1,eq-1)
		tv=substr(temp,eq+1)
		if(tn=="username")
		{
			if(urldecode(tv)!=name)
			{
				# print "Can't remove, post belongs to "substr(temp,eq+1)"."
				print "not removed."substr(temp,eq+1)"."
				close(postfile)
				return
			}
		}
		else if(tn=="password")
		{
			if(urldecode(tv)!=pass)
			{
				# print "Can't remove, wrong password."
				print "not removed"
				#I shouldn't tell why - the user can't be able to determine if post exists.
				close(postfile)
				return
			}
		}
	}
	
	if(f!="")
	{
		close(postfile)
		if(system("mv -f "postfile" "rmfile)==0)
		{
			print "removed."
			return
		}
	}
	f=""
	while((getline temp < stfile)>0)
	{
		f=1
		gsub(/[\r\n]/,"",temp)
		eq=index(temp,"=")
		tn=substr(temp,1,eq-1)
		tv=substr(temp,eq+1)
		if(tn=="username")
		{
			if(urldecode(tv)!=name)
			{
				print "Can't remove, post belongs to "substr(temp,eq+1)"."
				close(stfile)
				return
			}
		}
		else if(tn=="password")
		{
			if(urldecode(tv)!=pass)
			{
				print "Can't remove, wrong password."
				close(stfile)
				return
			}
		}
	}
	if(f!="")
	{
		close(stfile)
		if(system("mv -f "stfile" "rmfile)==0)
		{
			print "removed."
			return
		}
	}
	print "not removed."
}

function quote(   postid,postfile,stfile,temp,f,opt,cont,ongt,subj,eq,tn,tv,id)
{
	postid=sprintf("%04d%02d%02d%02d_%s",y,m,d,h,hexencode(name))
	postfile=postpath postid
	stfile=stpath postid
	
	while((getline temp < postfile)>0)
	{
		f=1
		gsub(/[\r\n]/,"",temp)
		eq=index(temp,"=")
		tn=substr(temp,1,eq-1)
		tv=substr(temp,eq+1)
		if(tn=="username")
		{
			if(urldecode(tv)!=name)
			{
				#print "Can't quote, post belongs to "substr(temp,eq+1)"."
				print " can't. quote." #I shouldn't tell why
				close(postfile)
				return
			}
		}
		else if(tn=="password")
		{
			if(urldecode(tv)!=pass)
			{
				#print "Can't quote, wrong password."
				print " can't quote." #I shouldn't tell why
				close(postfile)
				return
			}
		}
		else if(tn=="BB")
			cont=unhtml(tv)
		else if(tn=="brtext")
			ongt=tv
		else if(tn=="subject_h")
			subj=unhtml(tv)
		else if(tn=="disable_bbcode")
		{
			if(tv=="on")
				opt=opt"B"
		}
		else if(tn=="disable_smilies")
		{
			if(tv=="on")
				opt=opt"S"
		}
		else if(tn=="disable_magic_url")
		{
			if(tv=="on")
				opt=opt"U"
		}
		else if(tn=="attach_sig")
		{
			if(tv=="on")
				opt=opt"A"
		}
		else if(tn=="notify")
		{
			if(tv=="on")
				opt=opt"N"
		}
		else if(tn=="silent")
		{
			if(tv=="on")
				opt=opt"V"
		}
	}
	if(f!="")
	{
		close(postfile)
		if (opt=="")
			opt="_"
		print postid" subject "subj
		print postid" options "opt
		print postid" content "((ongt!="")?ongt:cont)
		return
	}
	
	while((getline temp < stfile)>0)
	{
		f=1
		gsub(/[\r\n]/,"",temp)
		eq=index(temp,"=")
		tn=substr(temp,1,eq-1)
		tv=substr(temp,eq+1)
		if(tn=="BB")
			cont=unhtml(tv)
		else if(tn=="brtext")
			ongt=tv
		else if(tn=="subject_h")
			subj=unhtml(tv)
		else if(tn=="ID")
			id=tv
		else if(tn=="disable_bbcode")
		{
			if(tv=="on")
				opt=opt"B"
		}
		else if(tn=="disable_smilies")
		{
			if(tv=="on")
				opt=opt"S"
		}
		else if(tn=="disable_magic_url")
		{
			if(tv=="on")
				opt=opt"U"
		}
		else if(tn=="attach_sig")
		{
			if(tv=="on")
				opt=opt"A"
		}
		else if(tn=="notify")
		{
			if(tv=="on")
				opt=opt"N"
		}
		else if(tn=="silent")
		{
			if(tv=="on")
				opt=opt"V"
		}
	}
	if(f!="")
	{
		close(stfile)
		if (opt=="")
			opt="_"
		print postid" subject "subj
		print postid" options "opt
		print postid" content "((ongt!="")?ongt:cont)
		if(id!="")
			print postid" ID "id
		return
	}
	
	else
		print postid " can't quote." #I shouldn't tell why
}

function list(   cmd,id,postfile,temp,mt,f,eq,tn,tv)
{
	
	if (flst!="")
	{
		cmd="/bin/ls -1 --color=never "stpath
		while ((cmd | getline id)>0)
		{
			f=""
			mt="[0-9]*_"hexencode(name)
			if(id !~ mt)
				continue
			stfile = stpath id
			#print id
			
			while((getline temp < stfile)>0)
			{
				f=1
				gsub(/[\r\n]/,"",temp)
				eq=index(temp,"=")
				tn=substr(temp,1,eq-1)
				tv=substr(temp,eq+1)
				if(tn=="subject_h")
					subj=unhtml(tv)
			}
			if(f!="")
			{
				close(stfile)
				print id" subject "subj
			}
		}
		close (cmd)
	}
	
	cmd="/bin/ls -1 --color=never "postpath
	while ((cmd | getline id)>0)
	{
		f=""
		mt="[0-9]*_"hexencode(name)
		if(id !~ mt)
			continue
		postfile = postpath id
		#print id
		
		while((getline temp < postfile)>0)
		{
			f=1
			gsub(/[\r\n]/,"",temp)
			eq=index(temp,"=")
			tn=substr(temp,1,eq-1)
			tv=substr(temp,eq+1)
			if(tn=="username")
			{
				if(urldecode(tv)!=name)
				{
					close(postfile)
					f=""
					break
				}
			}
			else if(tn=="password")
			{
				if(urldecode(tv)!=pass)
				{
					close(postfile)
					f=""
					break
				}
			}
			else if(tn=="subject_h")
				subj=unhtml(tv)
		}
		if(f!="")
		{
			close(postfile)
			print id" subject "subj
		}
		
		
		
		########33
	}
	close (cmd)
}

function post(   postid,replaceid,postfile,replacefile,temp,i,eq,tn,tv)
{
	if(lst!="")
		return list()
	if(quot!="")
		return quote()
	if(rmov!="")
		return remove()
	postid=sprintf("%04d%02d%02d%02d_%s",y,m,d,h,hexencode(name))
	printf("%s",postid" ")
	postfile=postpath postid
	
	if(options=="")
	{
		print "No options defined."
		return
	}
	
	# if(replace!="")
	# {
		# replaceid=replace"_"hexencode(name)
		# replacefile=postpath replaceid
	# }
	
	if (name=="")
	{
		print "Username missing."
		return
	}
	if (pass=="")
	{
		print "Password missing."
		return
	}
	if (subject=="")
	{
		print "Subject missing."
		return
	}
	if (content=="")
	{
		print "Post is empty."
		return
	}
	
	yy=y+0
	mm=m+0
	dd=d+0
	hh=h+0
	
	if(yy<yyy)
	{
		print "Can't post to the past."
		return
	}
	if(yy==yyy&&mm<mmm)
	{
		print "Can't post to the past."
		return
	}
	if(yy==yyy&&mm==mmm&&dd<ddd)
	{
		print "Can't post to the past."
		return
	}
	if(yy==yyy&&mm==mmm&&dd==ddd&&hh<=hhh)
	{
		print "Can't post to the past."
		return
	}
	
	split("", ongtable, ":")
	while((getline temp < postfile)>0)
	{
		gsub(/[\r\n]/,"",temp)
		eq=index(temp,"=")
		tn=substr(temp,1,eq-1)
		tv=substr(temp,eq+1)
		if(tn=="username")
		{
			if(urldecode(tv)!=name)
			{
				print "Can't replace, post belongs to "substr(temp,eq+1)
				close(postfile)
				return
			}
		}
		else if(tn=="password")
		{
			if(urldecode(tv)!=pass)
			{
				print "Can't replace, wrong password"
				close(postfile)
				return
			}
		}
		else if(tn ~ /^[ou]ngd?-[0-9]+$/)
		{
			ongtable[tn]=brunescape(tv)
		}
		else if(tn == "key")
			key=tv
	}
	close(postfile)
	
	# if(replace!="")
	# {
		# #print "Repalce post "replaceid
		# while((getline temp < replacefile)>0)
		# {
			# gsub(/[\r\n]/,"",temp)
			# eq=index(temp,"=")
			# if(substr(temp,1,eq-1)=="username")
			# {
				# if(substr(temp,eq+1)!=urlencode(name))
				# {
					# print "Can't replace, post belongs to "substr(temp,eq+1)
					# close(replacefile)
					# return
				# }
			# }
			# else if(substr(temp,1,eq-1)=="password")
			# {
				# if(substr(temp,eq+1)!=urlencode(pass,"all"))
				# {
					# print "Can't replace, wrong password"
					# close(replacefile)
					# return
				# }
			# }
		# }
		# close(replacefile)
		# system("rm -f " replacefile)
		
	# }
	printf("")>postfile
	
	print "timenumber="htmlescape(postid) >> postfile
	print "key="(key==""?newkey():key) >> postfile
	print "username="urlencode(name) >> postfile
	print "password="urlencode(pass,"all") >> postfile
	print "username_h="htmlescape(name) >> postfile
	
	# print("Post time:\n"d"."m"."y" "h":00")
	print "h="htmlescape(h) >> postfile
	print "d="htmlescape(d) >> postfile
	print "m="htmlescape(m) >> postfile
	print "y="htmlescape(y) >> postfile
	
	if(nobb!="")
		print "disable_bbcode=on" >> postfile
	if(nosmil!="")
		print "disable_smilies=on" >> postfile
	if(nourl!="")
		print "disable_magic_url=on" >> postfile
	if(sig!="")
		print "attach_sig=on" >> postfile
	if(notify!="")
		print "notify=on" >> postfile
	if(silent!="")
		print "silent=on" >> postfile
	
	print "subject="urlencode(subject) >> postfile
	print "subject_h="htmlescape(subject) >> postfile
	
	print "brtext="brescape(content) >> postfile
	
	gsub(/\[br\]/,"\n",content)
	
	for(i=0; content~/\[ong\]/; ++i)
	{
		tn=sprintf("ong-%u",i)
		ongtext = ongtable[tn]
		if (ongtext == "")
			ongtext=ong()
		print(tn"="brescape(ongtext)) >> postfile
		sub(/\[ong\]/,subescape(ongtext),content)
	}
	for(i=0; content~/\[ung\]/; ++i)
	{
		tn=sprintf("ung-%u",i)
		ongtext = ongtable[tn]
		if (ongtext == "")
			ongtext=ung()
		print(tn"="brescape(ongtext)) >> postfile
		sub(/\[ung\]/,subescape(ongtext),content)
	}
	for(i=0; content~/\[ong=decree\]/; ++i)
	{
		tn=sprintf("ongd-%u",i)
		ongtext = ongtable[tn]
		if (ongtext == "")
			ongtext=ong("decree")
		print(tn"="brescape(ongtext)) >> postfile
		sub(/\[ong=decree\]/,subescape(ongtext),content)
	}
	for(i=0; content~/\[ung=decree\]/; ++i)
	{
		tn=sprintf("ungd-%u",i)
		ongtext = ongtable[tn]
		if (ongtext == "")
			ongtext=ung("decree")
		print(tn"="brescape(ongtext)) >> postfile
		sub(/\[ung=decree\]/,subescape(ongtext),content)
	}
	
	# print "content:\n"content
	print "BBHTML="htmlescape(content,"","br") >> postfile
	print "BB="htmlescape(content,"less","br") >> postfile
	print "message="urlencode(content ((silent=="")?(nobb==""?"[right][size=80]-- posted by SilentBot [img]http://forums.xkcd.com/download/file.php?id=47884[/img][/size][/right]":"\n\n-- posted by SilentBot"):""))  >> postfile
	
	print "posted."
	system ("mawk -f "bb2html" -v outfile=\""postfile"\" \""postfile"\"")
	system ("wait 1")
	close (postfile)
}

function urlencode(name,all,   len,iii,escaped,ch)
{
	len=length(name)
	escaped=""
	for(iii=1;iii<=len;++iii)
	{
		ch=substr(name,iii,1);
		if ((ch ~ /[a-zA-Z0-9\.\-_~]/)&&(all==""))
			escaped = escaped ch
		else
			escaped = escaped "%" ch2hex[ch]
	}
	return escaped
}
function hexencode(name,   len,iii,escaped,ch)
{
	len=length(name)
	escaped=""
	for(iii=1;iii<=len;++iii)
	{
		ch=substr(name,iii,1)
		escaped = escaped ch2hex[ch]
	}
	return escaped
}
function subescape(subtext)
{
	gsub(/&/,"\\\\\\&",subtext)
	return subtext
}
	
function htmlescape(name,less,br,   len,iii,escaped,ch)
{
	len=length(name)
	escaped=""
	for(iii=1;iii<=len;++iii)
	{
		ch=substr(name,iii,1);
		if(ch == "\n")
			escaped = escaped ((br!="")?"<br>":"&#"ch2dec[ch]";")
		else if(ch =="\r")
			escaped = escaped ((br!="")?"":"&#"ch2dec[ch]";")
		else if(ch ~ /[\" ]/ && less=="")#"#"\""
			escaped = escaped "&#"ch2dec[ch]";"
		else if(ch ~ /[=<>&]/)
			escaped = escaped "&#"ch2dec[ch]";"
		else
			escaped = escaped ch
	}
	return escaped
}

function getmeme(decree   ,meme,i)
{
	if(decree!="" && lastdecr=="")
	{
		close(tempfile)
		system (automome" -lc 256 -n "memenumber" -d "memepath" -t \"[decr]\" > "tempfile)
	}
	else if(decree=="" && lastdecr!="")
	{
		close(tempfile)
		system (automome" -lc 256 -n "memenumber" -d "memepath" > "tempfile)
	}
	for(i=0;  ((getline meme < tempfile)<=0) && (i<3); ++i)
	{
		memenumber=memenumber*2
		close(tempfile)
		if(decree!="")
			system (automome" -lc 256 -n "memenumber" -d "memepath" -t \"[decr]\" > "tempfile)
		else
			system (automome" -lc 256 -n "memenumber" -d "memepath" > "tempfile)
	}
	lastdecr=decree
	return meme
}

function ong(decree,   line)
{
	# system (automome" -lc 256 -n 67 -d "memepath(decree!=""?" -t \"[decr]\"":"")" > "tempfile)
	
	while((line=getmeme(decree))!="")
	{
		gsub(/[\r\n]/,"",line)
		if(sub(/[AEIOUY]-N-G/,"#O-N-G#",line)>0)
			return preparebb(line)
		if(sub(/O+N+G+/,"#&#",line)>0)
			return preparebb(line)
		if(sub(/DON'T/,"D#ON'G#T",line)>0)
			return preparebb(line)
		if(sub(/[AEIOUY]NG/,"#ONG#",line)>0)
		{
			if($0!~/TH\[b\]ONG/)
				return preparebb(line)
		}
		if(sub(/ON /,"#ONG# ",line)>0)
			return preparebb(line)
		if(sub(/O\.?$/,"#ONG# ",$0)>0)
			return preparebb(line)
	}
	return "Ong"
}

function ung(decree,   line)
{
	# system (automome" -lc 256 -n 67 -d "memepath(decree!=""?" -t \"[decr]\"":"")" > "tempfile)
	
	while((line=getmeme(decree))!="")#((getline line < tempfile)>0)
	{
		gsub(/[\r\n]/,"",line)
		if(sub(/[AEIOUY]-N-G/,"#U-N-G#",line)>0)
			return preparebb(line)
		if(sub(/U+N+G+/,"#&#",line)>0)
			return preparebb(line)
		if(sub(/[AEIOUY]NG/,"#UNG#",line)>0)
			return preparebb(line)
		if(sub(/UN /,"#UNG# ",line)>0)
			return preparebb(line)
		if(sub(/U\.?$/,"#UNG# ",$0)>0)
			return preparebb(line)
	}
	return "Ung"
}
function preparebb(rh)
{
	if(nobb=="")
	{
		gsub(/\*\*/,"¤",rh)
		gsub(/\*[^\*]+\*/,"±&±",rh)
		gsub(/±\*/,"[i]",rh)
		gsub(/\*±/,"[/i]",rh)
		gsub(/¤/,"*",rh)
		
		gsub(/&&/,"¤",rh)
		gsub(/&[^&]+&/,"±&±",rh)
		gsub(/±&/,"[center][b]",rh)
		gsub(/&±/,"[/b][/center]",rh)
		gsub(/¤/,"\\&",rh)
		
		gsub(/__/,"¤",rh)
		gsub(/_[^_]+_/,"±&±",rh)
		gsub(/±_/,"[u]",rh)
		gsub(/_±/,"[/u]",rh)
		gsub(/¤/,"_",rh)
		
		gsub(/##/,"¤",rh)
		gsub(/#[^#]+#/,"±&±",rh)
		gsub(/±#/,"[b]",rh)
		gsub(/#±/,"[/b]",rh)
		gsub(/¤/,"#",rh)
		
		gsub(/\$\$/,"¤",rh)
		gsub(/\$[^\$]+\$/,"±&±",rh)
		gsub(/±\$/,"[size=80]",rh)
		gsub(/\$±/,"[/size]",rh)
		gsub(/¤/,"$",rh)
	}
	
	return rh (nobb==""?" -- [url=http://1190.bicyclesonthemoon.info/ongtext?b=on][b]ong[/b]o[/url][url=http://mrob.com/time/automome/]mome[/url]":" -- ongomome")
}
function unhtml(ht   ,i,j,un,num)
{
	gsub(/<br[ \t]*\/?>/,"[br]",ht)
	while ((i=match(ht, /&#[0-9]+;/))!=0)#
	{
		un=un substr(ht, 1, i-1)
		ht=substr(ht, i)
		j=index(ht, ";")
		num=int(substr(ht, 3, j-3))
		un=un sprintf("%c",num)
		ht=substr(ht, j+1)
	}
	un=un ht
	return un
}
function brescape(text) #there will be more
{
	gsub(/\r/,"",text)
	gsub(/\n/,"[br]",text)
	return text
}
function brunescape(text) #there will be more
{
	gsub(/\[br\]/,"\n",text)
	return text
}
function urldecode(ht   ,i,j,un,num)
{
	while ((i=match(ht, /%[0-9a-fA-F][0-9a-fA-F]/))!=0)#
	{
		un=un substr(ht, 1, i-1)
		ht=substr(ht, i)
		num=toupper(substr(ht, 2, 2))
		un=un hex2ch[num]
		ht=substr(ht, 4)
	}
	un=un ht
	return un
}
function newkey(   key,i,rn)
{
	for(i=0; i<8; ++i)
	{
		rn=int(rand()*65536)
		key = key sprintf("%04X",rn)
	}
	return key
}